package jp.hishidama.robot.ie;

import jp.hishidama.win32.com.ComPtr;
import jp.hishidama.win32.com.Variant;
import jp.hishidama.win32.mshtml.*;

/**
 * R{{bNXEXg{bNXxNX.
 * <p>
 * {@link IHTMLSelectElement}{@link IHTMLOptionElement}̃R{{bNXEXg{bNX𑀍삷NXłB<br> <a
 * target="hishidama"
 * href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">gp</a>
 * </p>
 * <p>
 * RXgN^[̈Ɏw肷HTMLvf́AĂяoŁiqvfɁjjĉB<br>
 * {@link jp.hishidama.robot.IERobot#getSelectById(String)}ɂēCX^X擾ꍇIERobotj܂B
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.10.24
 */
public class IHTMLSelectUtil {

	protected IHTMLSelectElement sel;

	/**
	 * RXgN^[.
	 * 
	 * @param select
	 *            selectvf
	 * @see jp.hishidama.robot.IERobot#getSelectById(String)
	 * @see jp.hishidama.robot.IERobot#getSelectByName(String, int)
	 */
	public IHTMLSelectUtil(IHTMLSelectElement select) {
		this.sel = select;
	}

	/**
	 * \s擾.
	 * <p>
	 * 1̂ƂR{{bNXA傫ƂXg{bNXB
	 * </p>
	 * 
	 * @return s
	 */
	public int getSize() {
		return sel.getSize();
	}

	/**
	 * \sݒ.
	 * 
	 * @param size
	 *            s
	 */
	public void setSize(int size) {
		sel.setSize(size);
	}

	/**
	 * sIێ擾.
	 * 
	 * @return sI\̂ƂAtrue
	 */
	public boolean isMultiple() {
		return sel.getMultiple();
	}

	/**
	 * sIېݒ.
	 * 
	 * @param b
	 *            trueFsI
	 */
	public void setMultiple(boolean b) {
		sel.setMultiple(b);
	}

	/**
	 * Isԍ擾.
	 * <p>
	 * IĂsindexԂB<br>
	 * sIĂꍇA擪indexԂ͗lB
	 * </p>
	 * 
	 * @return index
	 * @see #isSelected(int)
	 */
	public int getSelectedIndex() {
		return sel.getSelectedIndex();
	}

	/**
	 * Il擾.
	 * <p>
	 * IĂs̒lԂB<br>
	 * PƍsIŃTu~bgۂɑM̂́AԂ񂱂̒lB
	 * </p>
	 * 
	 * @return l
	 */
	public String getSelectedValue() {
		return sel.getValue();
	}

	/**
	 * PsI.
	 * <p>
	 * sIB<br>
	 * sȈꍇAI񂾍sȊO͑IB
	 * </p>
	 * 
	 * @param index
	 *            index
	 * @see #getSelectedIndex()
	 */
	public void setSelected(int index) {
		sel.setSelectedIndex(index);
	}

	/**
	 * lݒ.
	 * 
	 * @param value
	 *            l
	 * @see #getSelectedValue()
	 */
	public void setSelected(String value) {
		sel.setValue(value);
	}

	/**
	 * Iǉ.
	 * 
	 * @param index
	 *            ǉʒu
	 * @param text
	 *            \eLXg
	 * @param value
	 *            l
	 * @param defaultSelected
	 *            ftHgIL
	 * @param selected
	 *            IL
	 */
	public void add(int index, String text, String value,
			boolean defaultSelected, boolean selected) {
		IHTMLDocument doc = null;
		IHTMLOptionElement opt = null;
		try {
			doc = sel.getDocument();
			IHTMLWindow win = doc.getParentWindow();
			opt = IHTMLOptionElement.create(win, text, value, defaultSelected,
					selected);
			sel.add(opt, new Variant(index));
			opt.setSelected(selected);
		} finally {
			ComPtr.dispose(opt);
			ComPtr.dispose(doc);
		}
	}

	/**
	 * I폜.
	 * 
	 * @param index
	 *            폜ʒu
	 */
	public void remove(int index) {
		sel.remove(index);
	}

	/**
	 * selectvf擾.
	 * <p>
	 * \bhɂĎ擾HTMLvf́ARXgN^[ĂяoIuWFNgɂĔjB
	 * </p>
	 * 
	 * @return selectvf
	 */
	public IHTMLSelectElement getElement() {
		return sel;
	}

	/**
	 * 擾.
	 * 
	 * @return Ǐ
	 */
	public int size() {
		return sel.getLength();
	}

	/**
	 * optionvf擾.
	 * <p>
	 * \bhɂĎ擾HTMLvf́ARXgN^[ĂяoIuWFNgɂĘAĔjB
	 * </p>
	 * 
	 * @param index
	 *            index
	 * @return optionvf
	 */
	public IHTMLOptionElement getElement(int index) {
		return sel.item(index);
	}

	/**
	 * גl擾.
	 * 
	 * @param index
	 *            index
	 * @return l
	 */
	public String getValue(int index) {
		IHTMLOptionElement o = sel.item(index);
		try {
			return o.getValue();
		} finally {
			ComPtr.dispose(o);
		}
	}

	/**
	 * ׃eLXg擾.
	 * 
	 * @param index
	 *            index
	 * @return IƂĕ\Ă镶
	 */
	public String getText(int index) {
		IHTMLOptionElement o = sel.item(index);
		try {
			return o.getText();
		} finally {
			ComPtr.dispose(o);
		}
	}

	/**
	 * IL擾.
	 * 
	 * @param index
	 *            index
	 * @return IĂꍇAtrue
	 */
	public boolean isSelected(int index) {
		IHTMLOptionElement o = sel.item(index);
		try {
			return o.getSelected();
		} finally {
			ComPtr.dispose(o);
		}
	}

	/**
	 * ILݒ.
	 * 
	 * @param index
	 *            index
	 * @param b
	 *            IL
	 */
	public void setSelected(int index, boolean b) {
		IHTMLOptionElement o = sel.item(index);
		try {
			o.setSelected(b);
		} finally {
			ComPtr.dispose(o);
		}
	}

}
